// 006 u_gof_chain_of_responsibility
// 17 oct 2004

// -- Delphi implementation from the book:
// --   Design Patterns Elements of Reusable Object-Oriented Software
// --   Addison Wesley - 1994 - ISBN 0-201-63361-2
// -- (C) Erich GAMMA, Richard HELM, Ralph JOHNSON, John VLISSIDES 1994

// -- translation from C to Delphi performed by
// --   John COLIBRI  http://www.jcolibri.com

(*$r+*)

unit u_gof_chain_of_responsibility;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    exit_: TButton;
    clear_: TButton;
    get_help_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure get_help_Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

    var Form1: TForm1;

  implementation
    uses u_types_constants, u_c_log, u_c_display
        , u_dir, u_file

        , u_c_help_handler_13
    ;

    {$R *.DFM}

 
    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // close_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.get_help_Click(Sender: TObject);
      const k_print_help_topic= 1;
            k_paper_orientation_help_topic= 2;
            k_application_help_topic= 3;
      var l_c_application: c_application;
          l_c_dialog: c_dialog;
          l_c_button: c_button;
      begin
        l_c_application:= c_application.create_application(k_application_help_topic);
        l_c_dialog:= c_dialog.create_dialog(l_c_application, k_print_help_topic);
        l_c_button:= c_button.create_button(l_c_dialog, k_paper_orientation_help_topic);

        l_c_button.handle_help;
      end; // get_help_Click

end.


